Attribute VB_Name = "Other"
'Windows functions to make splash transparent.
'Windows 2000/XP only
'Icon subs

Option Base 1
Option Explicit


'constants for Help system
 Public Const HH_DISPLAY_TOPIC = &H0
    Const HH_SET_WIN_TYPE = &H4
    Const HH_GET_WIN_TYPE = &H5
    Const HH_GET_WIN_HANDLE = &H6
    Const HH_DISPLAY_TEXT_POPUP = &HE   ' Display string resource ID or
                                        ' text in a pop-up window.
    Const HH_HELP_CONTEXT = &HF         ' Display mapped numeric value in
                                        ' dwData.
    Const HH_TP_HELP_CONTEXTMENU = &H10 ' Text pop-up help, similar to
                                        ' WinHelp's HELP_CONTEXTMENU.
    Const HH_TP_HELP_WM_HELP = &H11     ' text pop-up help, similar to
                                          ' WinHelp's HELP_WM_HELP.


Private Const GWL_EXSTYLE = (-20)
Private Const WS_EX_LAYERED = &H90000
Private Const LWA_ALPHA = &H2

Private Declare Function GetWindowLong Lib "user32" _
  Alias "GetWindowLongA" (ByVal hWnd As Long, _
  ByVal nIndex As Long) As Long

Private Declare Function SetWindowLong Lib "user32" _
   Alias "SetWindowLongA" (ByVal hWnd As Long, _
   ByVal nIndex As Long, ByVal dwNewLong As Long) _
   As Long

Private Declare Function SetLayeredWindowAttributes Lib _
    "user32" (ByVal hWnd As Long, ByVal crKey As Long, _
    ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long



'public  Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hwnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)
Public Declare Function HtmlHelp Lib "hhctrl.ocx" Alias "HtmlHelpA" _
         (ByVal hwndCaller As Long, ByVal pszFile As String, _
         ByVal uCommand As Long, ByVal dwData As Long) As Long



Public Function TranslucentForm(frm As Form, TranslucenceLevel As Byte) As Boolean
'**************************************************
'PURPOSE: Makes a form translucent (semi-transparent)

'PARAMETERS: frm -- the form to be translucent
'TranslucenceLevel -- number ranging from 0 to 255
  '0 = completely transparent, 255 = completely opaque

'EXAMPLE: Makes form 50% transparent
'Private Sub Form_Load()
'TranslucentForm Me, 128

'End Sub

'RETURNS: TRUE IF SUCCESSFUL, FALSE OTHERWISE

'REQUIRES: Windows2000
'************************************************
On Error Resume Next

SetWindowLong frm.hWnd, GWL_EXSTYLE, WS_EX_LAYERED

SetLayeredWindowAttributes frm.hWnd, 0, TranslucenceLevel, LWA_ALPHA

TranslucentForm = Err.LastDllError = 0

End Function
