Attribute VB_Name = "S1VStruct"
'Module for EX5-stuff

Option Base 1
Option Explicit


Public Type VoiceType                   'structuur van de Voice SubChunk, zie tabel 11
    Naam As String                          '12 0       (Lengte, offset)
    Category As Variant                     '1  12      (rest = 236 - 12 = 224)
    Volume As Variant                       '1  13
    DrumLayerCount As Variant               '1  14
    VelocitySenseDepth As Variant           '1  15
    VelocitySenseOffset As Variant          '1  16
    ReverbSendLevel As Variant              '1  17
    ChorusSendLevel As Variant              '1  18
    ReverbType As Variant                   '1  19
    ReverbParByte(12) As Variant            '1  20
    ReverbParWord(2) As Variant             '2  32
    ReverbReturn As Variant                 '1  36
    ReverbPan As Variant                    '1  37
    Reserve1 As Variant                     '1  38
    ChorusType As Variant                   '1  39
    ChorusParWord(4) As Variant             '2  40
    ChorusParByte(8) As Variant             '1  48
    ChorusReturn As Variant                 '1  56
    ChorusPan As Variant                    '1  57
    Chorus2Reverb As Variant                '1  58
    InsVoiceType As Variant                 '1  59
    InsertionSType As Variant               '1  60
    InsertionSPar(15) As Variant            '1  61
    FDSPPan As Variant                      '1  76
    InsertionLType As Variant               '1  77
    InsertionLPar(16) As Variant            '2  78
    ArpTempoControl As Variant              '1  110
    Reserve2 As Variant                     '2  111
    Ins2ReverbSendLevel As Variant          '1  113
    Ins2ChorusSendLevel As Variant          '1  114
    InsLargeSmallFDSPType As Variant        '1  115
    FDSPPar(20) As Variant                  '1  116
    ModePortSW As Variant                   '1  136
    PortamentTime As Variant                '1  137
    BendWheelAssignSW As Variant            '2  138
    ModulationWheelAssignSW As Variant      '2  140
    CHAfterAssignSW As Variant              '2  142
    ModulationWheel2AssignSW As Variant     '2  144
    FootControllerAssignSW As Variant       '2  146
    BreathControllerAssignSW As Variant     '2  148
    RibbonControllerAssignSW As Variant     '2  150
    KnobAssignSW(6) As Variant              '2  152
    VCControlDepth(16) As Variant           '1  164
    VCDestinationAssignNr(16) As Variant    '1  180
    VCDestinationAssignElem(16) As Variant  '1  196
    PitchBendUpperDepth As Variant          '1  212
    PichBendLowerDepth As Variant           '1  213
    Knob1Scene1 As Variant                  '1  214
    Knob1Scene2 As Variant                  '1  215
    Knob1Initial As Variant                 '1  216
    Knob2Scene1 As Variant                  '1  217
    Knob2Scene2 As Variant                  '1  218
    Knob2Initial As Variant                 '1  219
    Knob3Scene1 As Variant                  '1  220
    Knob3Scene2 As Variant                  '1  221
    Knob3Initial As Variant                 '1  222
    Knob4Scene1 As Variant                  '1  223
    Knob4Scene2 As Variant                  '1  224
    Knob4Initial As Variant                 '1  225
    Knob5Scene1 As Variant                  '1  226
    Knob5Scene2 As Variant                  '1  227
    Knob5Initial As Variant                 '1  228
    Knob6Scene1 As Variant                  '1  229
    Knob6Scene2 As Variant                  '1  230
    Knob6Initial As Variant                 '1  231
    ArpOnType As Variant                    '1  232
    ArpNoteLimitLow As Variant              '1  233
    ArpNoteLimitHigh As Variant             '1  234
    ArpTempo As Variant                     '1  235
End Type


Public Type S1VType                         'layout S1V file
    Header As String                        '16
    dummy As String                         '112
    ElementsIndex(1024) As String           '1024 * 2
'    Voice(256) As VoiceType                 '256 * 236 verwijderd; werd te lang
    Element(1024) As String                 '1024 * 132
End Type

Public Type WaveHeaderType                  'see description in Excelfile
    name As String                          '8
    Layers As Integer                       '2
    length As Long                          '3
    Layernumber As Integer                 '1
    dummy1 As String                       '16, TBD
End Type

Public Type SampleHeaderType                'see description in Excelfile
    name As String                          '8
    dummy1 As String                        '6, TBD
    length As Long                          '3
    dummy2 As String                        '1, TBD
    dummy3 As String                        '12
    dummy4 As String                        '1002
End Type

Public S1V As S1VType
Public Voice(256) As VoiceType
Public WaveHeader(1024) As WaveHeaderType
Public SampleHeader(1024) As SampleHeaderType
